
// $Id: JDOMRSS2HTML.java,v 1.1 2001/03/11 14:52:40 larsga Exp $

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import org.jdom.*;
import org.jdom.input.SAXBuilder;

public class JDOMRSS2HTML {

  public static void main(String[] args) {
    try {
      convert(args[0], args[1]);
    }
    catch (JDOMException e) {
      System.err.println("ERROR: " + e);
    }
    catch (IOException e) {
      System.err.println("ERROR: " + e);
    }
  }

  public static void convert(String infile, String outfile)
    throws JDOMException, IOException {
    FileWriter writer = new FileWriter(outfile);
    
    SAXBuilder builder = new SAXBuilder();
    Document doc = builder.build(new File(infile));
    Element rss = doc.getRootElement();
    Element channel = rss.getChild("channel");
    String title = channel.getChildText("title");
    String link = channel.getChildText("link");
    Element descr = channel.getChild("description");
    
    writer.write("<html>\n");
    writer.write("<title>" + title + "</title>\n");
    writer.write("<h1><a href=\"" + link + "\">" + title + "</a></h1>\n");

    if (descr != null)
      writer.write("<p>" + descr.getText()  + "</p>\n");

    writer.write("<ul>\n");
    Iterator it = channel.getChildren("item").iterator();
    while (it.hasNext()) {
      Element item = (Element) it.next();
      writer.write("  <li><a href=\"" + item.getChildText("link") + "\">" +
		   item.getChildText("title") + "</a>");

      descr = item.getChild("descr");
      if (descr != null)
	writer.write(" " + descr.getText() + "</li>\n");
      else
	writer.write("</li>\n");
    }
    writer.write("</ul>\n");
    
    writer.write("</html>\n");
    writer.close();
  }
  
}
