
import java.io.File;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

public class XSLTRunner {

  public static void main(String[] args) {
    if (args.length != 3) {
      System.err.println("Wrong number of arguments.");
      System.err.println("Usage:");
      System.err.println("  java XSLTRunner <infile> <xsltfile> <outfile>");
      return;
    }

    try {
      run(args[0], args[1], args[2]);
    }
    catch (TransformerConfigurationException e) {
      System.err.println("ERROR: " + e);
    }
    catch (TransformerException e) {
      System.err.println("ERROR: " + e);
    }
  }

  public static void run(String infile, String xsltfile, String outfile)
    throws TransformerConfigurationException, TransformerException {
    
    TransformerFactory factory = TransformerFactory.newInstance();
    Transformer processor =
      factory.newTransformer(new StreamSource(new File(xsltfile)));
    processor.transform(new StreamSource(new File(infile)),
			new StreamResult(new File(outfile)));
  }
  
}
