
// $Id: SAXTracker.java,v 1.1 2001/03/25 19:08:02 larsga Exp $

import java.util.HashSet;
import java.util.Set;
import java.util.Stack;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public abstract class SAXTracker extends DefaultHandler {
  protected Set          keepContentsOf;
  protected StringBuffer content;
  private   boolean      keepContents;
  protected Stack        openElements;

  // --- Configuration interface
  
  public SAXTracker() {
    keepContentsOf = new HashSet();
    openElements = new Stack();
  }

  public void keepContentsOf(String elementName) {
    keepContentsOf.add(elementName);
  }
  
  // --- Utility interface

  public boolean isParent(String localName) {
    return !openElements.isEmpty() && openElements.peek().equals(localName);
  }
  
  // --- ContentHandler interface
  
  public void startElement(String nsuri, String lname, String qname,
			   Attributes attrs) throws SAXException {
    openElements.push(lname);

    keepContents = keepContentsOf.contains(lname);
    if (keepContents)
      content = new StringBuffer();
  }

  public void characters(char[] chars, int start, int length) 
    throws SAXException {
    if (keepContents)
      content.append(chars, start, length);
  }
    
  public void endElement(String nsuri, String lname, String qname) 
    throws SAXException {
    keepContents = false;
    openElements.pop();
  }
}
