
import java.io.*;
import javax.xml.parsers.*;
import org.xml.sax.*;

public class XBELUtilities {

  public static BookmarkCollection read(String uri)
  throws SAXException, IOException, java.net.MalformedURLException,
         ParserConfigurationException{
    XBELContentHandler handler = new XBELContentHandler(uri);
    XMLReader parser = getXMLReader();
    parser.setContentHandler(handler);
    parser.parse(uri);
    return handler.getBookmarkCollection();
  }

  public static void main(String[] args) {
    try {
      BookmarkCollection bookmarks =
        read(new File(args[0]).toURL().toString());
      System.out.println("title: " + bookmarks.getTitle());
      System.out.println("descr: " + bookmarks.getDescription());
    }
    catch (Exception e) {
      e.printStackTrace();
      System.err.println("ERROR: " + e);
    }
  }
  
  private static XMLReader getXMLReader()
    throws SAXException, ParserConfigurationException {
    SAXParserFactory factory = SAXParserFactory.newInstance();
    SAXParser parser = factory.newSAXParser();
    return parser.getXMLReader();
  }  

}
