import sys
from xml.dom.minidom import parse       # We use minidom

# --- Templates

top = \
"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <TITLE>%s</TITLE>
</HEAD>

<BODY>
"""

bottom = \
"""       
<HR>

<ADDRESS>
Converted to HTML by rss2html.py.
</ADDRESS>

</BODY>
</HTML>
"""

# --- The converter

def conv2html(root, out = None):
    out = out or sys.stdout
    
    title = data(root.getElementsByTagName("title")[0])
    link = data(root.getElementsByTagName("link")[0])
    channel = root.getElementsByTagName("channel")[0]
    descr = channel.getElementsByTagName("description")
    if descr != []:
        descr = data(descr[0])
    else:
        descr = None
    
    out.write(top % title)
    out.write('<h1><a href="%s">%s</a></h1>\n' % (link, title))
    if descr:
        out.write('<p>%s</p>\n\n' % descr)

    out.write("<ul>\n")
    for item in root.getElementsByTagName("item"):
        convitem(item, out)
    out.write("</ul>\n")

    out.write(bottom)

def convitem(item, out):
    title = data(item.getElementsByTagName("title")[0])
    link = data(item.getElementsByTagName("link")[0])
    descr = item.getElementsByTagName("description")
    if descr != []:
        descr = data(descr[0])
    else:
        descr = ""

    out.write('  <li><a href="%s">%s</a> %s\n' % (link, title, descr))
        
# --- Utilities

def data(element):
    return element.firstChild.nodeValue

# --- Main program

doc = parse(sys.argv[1])
root = doc.documentElement
conv2html(root)
