from xml.dom import ext
from xml.dom.ext.reader.Sax2 import Reader

ELEMENT_NODE = 1


def create_item(doc, title, link, desc = None):
    item = doc.createElement("item")
    item.appendChild(doc.createTextNode("\n"))
    
    title_elm = doc.createElement("title")
    title_elm.appendChild(doc.createTextNode(title))
    item.appendChild(title_elm)
    item.appendChild(doc.createTextNode("\n"))
    
    link_elm = doc.createElement("link")
    link_elm.appendChild(doc.createTextNode(link))
    item.appendChild(link_elm)
    item.appendChild(doc.createTextNode("\n"))

    if desc:
        desc_elm = doc.createElement("desc")
        desc_elm.appendChild(doc.createTextNode(desc))
        item.appendChild(desc_elm)
        item.appendChild(doc.createTextNode("\n"))

    return item


def insert_item(doc, item):
    # find out where to insert the new item
    first_item = None
    root = doc.documentElement
    for child in root.childNodes:
        if child.nodeType == ELEMENT_NODE and \
           child.nodeName == "item":
            first_item = child
            break

    # here, first_item is either the first item element in the document
    # or None if there are no item elements in the document

    if first_item:
        root.insertBefore(item, first_item)
        root.insertBefore(doc.createTextNode("\n\n"), first_item)
    else:
        root.appendChild(item)


def add_item(filename, title, link, desc = None):
    doc = Reader().fromStream(open(filename))
    item = create_item(doc, title, link, desc)
    insert_item(doc, item)

    outf = open(filename, "w")
    ext.Print(doc, outf)
    outf.close()


if __name__ == "__main__":
    import sys
    add_item(sys.argv[1], "New item!", "http://www.garshol.priv.no")
