import sys
from eventdom.eventdom import *
from domutils import *

# --- Templates

top = \
"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <TITLE>%s</TITLE>
</HEAD>

<BODY>
<H1><A HREF="%s">%s</A></H1>
"""

bottom = \
"""
<HR>
<ADDRESS>
Converted from RSS to HTML with eventdom.
</ADDRESS>

</BODY>
</HTML>
"""


# --- Handler class

class RSSHandler(EventDOMHandler):

    def __init__(self, out = None):
        EventDOMHandler.__init__(self)
        self._out = out or sys.stdout


    # handler methods

    def channel(self, node):
        ' process: channel '

        title = data(find_first_child(node, ELEMENT_NODE, 'title'),
                     '<no title>')
        link  = data(find_first_child(node, ELEMENT_NODE, 'link'),
                     '<no link>')
        descr = data(find_first_child(node, ELEMENT_NODE, 'description'),
                     None)

        self._out.write(top % (title, link, title))
        if descr:
            self._out.write("<p>%s</p>\n" % descr)
            
        self._out.write("<ul>\n")
        self.processChildren(node)
        self._out.write("</ul>\n")

        self._out.write(bottom)


    def item(self, node):
        ' process: item '
        title = data(find_first_child(node, ELEMENT_NODE, 'title'),
                     '<no title>')
        link  = data(find_first_child(node, ELEMENT_NODE, 'link'),
                     '<no link>')
        descr = data(find_first_child(node, ELEMENT_NODE, 'description'),
                     '')
        
        self._out.write('  <li><a href="%s">%s</a> %s</li>\n' %
                        (link, title, descr))


# --- Main program

def _test(file):
    parse_file(file, RSSHandler())

if __name__ == "__main__":
    _test(sys.argv[1])
