
import string

# --- Global variables
    
total_hits   = 0
hits_by_page = {}  # maps document URL to hit count for that document

# --- Functions

def read_logfile(filename):
    inf = open(filename)

    line = inf.readline()
    while line != "":
        fields = string.split(line)
        process_request(fields[0], fields[3], fields[4], fields[5], fields[6],
                        fields[7], fields[8], fields[9])

        line = inf.readline()
    
    inf.close()

def process_request(host, date, timezone, method, url, protocol, code, bytes):
    global total_hits

    if code > "399": return # request was not successful, so don't count it
        
    total_hits = total_hits + 1

    url = string.split(url, "?")[0] # remove script arguments, if any
    
    if hits_by_page.has_key(url):
        hits_by_page[url] = hits_by_page[url] + 1
    else:
        hits_by_page[url] = 1

report_top = \
"""
<title>Web server statistics</title>
<h1>Web server statistics</h1>
<table>
<tr><th>Total number of hits:  <td>%d
<tr><th>Total number of pages: <td>%d
</table>
"""
        
def produce_report():
    print report_top % (total_hits, len(hits_by_page))

    pages = []
    for (url, hits) in hits_by_page.items():
        pages.append((hits, url))
    pages.sort()
    pages.reverse()

    print "<table>"
    print "<tr><th>Page   <th>Hits"
    for (hits, url) in pages:
        print "<tr><td>%s <td>%d" % (url, hits)
    print "</table>"
        
# --- Main program

import sys

if len(sys.argv) != 2:  # script name is sys.argv[0]
    print "Usage: %s <log file name>" % sys.argv[0]
    sys.exit(1)

read_logfile(sys.argv[1])
produce_report()
