import xmllib, sys

# --- The xmllib application
    
class StatsGatherer(xmllib.XMLParser):

    def __init__(self):
        xmllib.XMLParser.__init__(self) # important: initializes xmllib
        self._elems       = {}
        self._pis         = {}
        self._data_blocks = 0
        self._data_len    = 0


    def unknown_starttag(self, name, atts):
        self._elems[name] = self._elems.get(name, 0) + 1


    def handle_data(self, data):
        self._data_blocks = self._data_blocks + 1
        self._data_len = self._data_len + len(data)

    def handle_cdata(self, data):
        self.handle_data(data)


    def handle_proc(self, target, data):
        self._pis[target] = self._pis.get(target, 0) + 1
            
    def print_stats(self):
        print "Data blocks: %d" % self._data_blocks
        print "Data length: %d" % self._data_len
        print "\n---Elements"
        for pair in self._elems.items():
            print "%s: %d" % pair
            
        print "\n---PIs"
        for pair in self._pis.items():
            print "%s: %d" % pair


# --- Main program

inf = open(sys.argv[1])
p = StatsGatherer()
buf = inf.read(1024)
while buf != "":
    p.feed(buf)
    buf = inf.read(1024)
p.close()

p.print_stats()

