import sys
import xmlgen
import random
from xml.parsers.xmlproc import xmldtd

used_ids = []

def generate_value(attr_type):
    if type(attr_type) == type([]):
        return random.choice(attr_type)
    elif attr_type == "ID":
        id = "id%d" % len(used_ids)
        used_ids.append(id)
        return id
    elif attr_type == "IDREF":
        if used_ids == []:
            return "id0"
        else:
            return random.choice(used_ids)
    else:
        # missing: handling of ENTITY, ENTITIES and NOTATION
        return "attrval" # always a valid value


def generate_attributes(elemdef):
    attrs = {}
    for aname in elemdef.get_attr_list():
        attr = elemdef.get_attr(aname)
        include = random.choice([0, 1])

        if attr.get_decl() == "#FIXED":
            value = attr.get_default()
        elif attr.get_decl() == "#DEFAULT":
            if include:
                value = attr.get_default()
            else:
                value = generate_value(attr.get_type())
        elif attr.get_decl() == "#REQUIRED" or include:
            value = generate_value(attr.get_type())
        else:
            continue

        attrs[aname] = value

    return attrs


def generate_element(name, dtd, gen):
    elemdef = dtd.get_elem(name)
    gen.startElement(name, generate_attributes(elemdef))

    state = elemdef.get_start_state()
    while (not elemdef.final_state(state)) or random.choice([0, 1, 1, 1]):
        valid = elemdef.get_valid_elements(state)
        if valid == []:
            break

        next = random.choice(valid)
        if next == "#PCDATA":
            gen.characters("This is text. ")
        else:
            generate_element(next, dtd, gen)
        state = elemdef.next_state(state, next)
    
    gen.endElement(name)


def generate_document(dtdfile, doc_elem, outfile):
    dtd = xmldtd.load_dtd(dtdfile)
    gen = xmlgen.file_writer(outfile)

    generate_element(doc_elem, dtd, gen)

    gen.close()


if __name__ == "__main__":
    generate_document(sys.argv[1], sys.argv[2], sys.argv[3])
