#!/usr/bin/python
"""
This RSS client informs listed users of new stories via email every
time it is run.

$Id: rss-email.py,v 1.3 2001/01/12 08:16:54 larsga Exp $
"""

import smtplib, StringIO, sys
import clientlib, config

# --- Main program

errors = clientlib.ErrorRecorder()
summaries = clientlib.get_summaries(errors)

stories = []

for summary in summaries:
    for item in summary.get_items():
        story = clientlib.Story(summary, item)
        if clientlib.cache.show(story):
            clientlib.cache.read(story)
            stories.append(story)

if stories == [] and errors._errors == []:
    sys.exit()

stories.sort()

smtp = smtplib.SMTP(config.get_mail_server())
for recipient in config.get_recipients():
    email = StringIO.StringIO()
    email.write(("From: rss-email client <%s>\n"
                 "To: %s\n"
                 "Subject: New RSS stories\n\n") %
                (config.get_from_addr(), recipient))

    for story in stories:
        email.write(("---%s:\n"
                     "  <URL: %s >\n") %
                    (story.get_title(), story.get_link()))
        if story.get_description():
            email.write("\n" + story.get_description() + "\n")

        email.write("\n")

    if errors._errors != []:
        email.write("===== ERRORS =====\n\n")
        for error in errors._errors:
            email.write("  " + error + "\n")

    email.write("\n-- \nThe RSS email client")
    
    smtp.sendmail(config.get_from_addr(), [recipient],
                  email.getvalue())

smtp.quit()
