import sys
from XMLinter import *

# --- Templates

top = \
"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <TITLE>%s</TITLE>
</HEAD>

<BODY>
<A HREF="%s"><H1>%s</H1></A>
"""

bottom = \
"""
</UL>

<HR>

<ADDRESS>
Converted to HTML using RXP.
</ADDRESS>

</BODY>
</HTML>
"""


# --- Conversion

def convert_file(filename, outf):
    convert(Open(filename, NSL_read), outf)


def convert(file, outf):
    parent = None
    title  = None
    first_item = 1
    
    while 1:
        bit = GetNextBit(file)
        
        if bit.type == 'start':
            parent = bit.label

            if bit.label == 'item':
                if first_item:
                    outf.write('<ul>\n')
                    first_item = 0
                    
                convert_item(file, outf)

        elif bit.type == 'text':
            if parent == 'title':
                title = bit.body
            elif parent == 'link':
                outf.write(top % (title, bit.body, title))
            elif parent == 'description':
                outf.write('<p>%s</p>\n' % bit.body)

        elif bit.type == 'end':
            parent = None
            
            if bit.label == 'rss':
                outf.write(bottom)
                break


def convert_item(file, outf):
    parent = None
    title  = None
    link   = None
    descr  = ""
    
    while 1:
        bit = GetNextBit(file)

        if bit.type == 'start':
            parent = bit.label

        elif bit.type == 'text':
            if parent == 'title':
                title = bit.body
            elif parent == 'link':
                link = bit.body
            elif parent == 'description':
                descr = bit.body

        elif bit.type == 'end':
            parent = None
            
            if bit.label == 'item':
                outf.write('  <li><a href="%s">%s</a> %s</li>\n' %
                           (link, title, descr))
                break
