
import string, os
import xml.dom.ext
from xml.xslt import XsltElement, XSL_NAMESPACE
from xml.xslt.AttributeValueTemplate import AttributeValueTemplate
from xml.xpath import CoreFunctions, XPathParser

class DebugElement(XsltElement):

    legalAttrs = ('select', 'filename')
    
    def setup(self):
        self.__dict__['_nss'] = xml.dom.ext.GetAllNs(self)
        self.__dict__['_filename'] = \
            AttributeValueTemplate(self.getAttributeNS('', 'filename'))
        parser = XPathParser.XPathParser()
        self.__dict__['_select'] = \
            parser.parseExpression(self.getAttributeNS('', 'select'))

    def instantiate(self, context, processor):
        orig_state = context.copy()
        context.setNamespaces(self._nss)

        filename = self._filename.evaluate(context)
        value = CoreFunctions.String(context, self._select.evaluate(context))

        outf = open(filename, 'a')
        outf.write(value + '\n')
        outf.close()

        context.set(orig_state)
        return (context,)

ExtElements = {
    ('http://garshol.priv.no/symbolic/', 'debug'): DebugElement
    }
