
import string
from xml.dom.Text import Text
from xml.xpath.CoreFunctions import String, Number, Boolean
        
def distinct(context, nodeset):
    if type(nodeset) != type([]):
        raise Exception("'distinct' parameter must be of type node-set!")
    
    nodes = {}
    for node in nodeset:
        nodes[String(context, node)] = node

    return nodes.values()


def split(context, str, delim = None):
    doc = context.node
    while doc.parentNode:
        doc = doc.parentNode
    
    nodeset = []    
    for token in string.split(String(context, str), delim):
        nodeset.append(doc.createTextNode(token))

    return nodeset


def range(context, lo, hi):
    doc = context.node
    while doc.parentNode:
        doc = doc.parentNode
        
    lo = Number(context, lo)
    hi = Number(context, hi)
    
    nodeset = []    
    for number in xrange(lo, hi):
        nodeset.append(doc.createTextNode(str(number)))

    return nodeset


def if_function(context, cond, v1, v2):
    if Boolean(cond):
        return v1
    else:
        return v2
    

def find(context, str, substr):
    return string.find(String(context, str), String(context, substr))
    

ExtFunctions = {
    ('http://garshol.priv.no/symbolic/', 'distinct') : distinct,
    ('http://garshol.priv.no/symbolic/', 'split')    : split,
    ('http://garshol.priv.no/symbolic/', 'range')    : range,
    ('http://garshol.priv.no/symbolic/', 'if')       : if_function,
    ('http://garshol.priv.no/symbolic/', 'find')     : find
}
